import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {
	
		/* Do not modify this function. You also do not need to understand it
		 * and may treat it as a blackbox. */
		public static int f(int x) {
				int r = 0, z = x;
				while (z > 0) {
						r = r + x;
						z = z / 2;
				}
				return r;
		}

		/* This function looks for x such that f(x) == a in the range left .. right.
		 * Returns the desired x, or -1 if it does not exist in the range left .. right.
		 * Note that the range size decreases to approximately half with every call,
		 * making the time complexity O(log(right-left)) */
		public static int binarySearch(int a, int left, int right) {
				// The range is empty, so no such x exists in it
				if (left > right)
						return -1;
				
				// Middle of the interval (may be equal to left and/or right)
				int middle = (left + right) / 2;
				int middle_val = f(middle);
				
				// At most one of these will hold and binarySearch is called at most once.
				if (middle_val > a)
						return binarySearch(a, left, middle - 1);
				if (middle_val < a)
						return binarySearch(a, middle + 1, right);
				
				// If none of the above hold, it must be that middle_val == a
				return middle;
		}
		
		public static void main(String[] args) {
        	
                // Read from the standard input with java.util.Scanner
                Scanner scanner = new Scanner(System.in);
                int n = scanner.nextInt();
                
                // x_max from the task
                int x_max = 20000000;
             
                // Read n integers and for each run the bisection
                // Note: we do not allocate array, since we only need to process one
                // value at a time.
                int i;
                for (i = 0; i < n; i++) {
                		// Load the next value (a_i) into a
                        int a = scanner.nextInt();
                        
                        // Put your implementation here, calling f as required
                        
                        // Call the search for the full range
                        int x = binarySearch(a, 0, x_max);
                        
                        if (x == -1) {
                        		System.out.println("NO");
                        } else {
                        		System.out.println(x);
                        }
                }
                scanner.close();
        }
}
